function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
import React, { Component } from "react";
import { Form } from "react-bootstrap";
import { schemaRequiresTrueValue } from "@rjsf/core/lib/utils";
var CheckboxDetailField = /*#__PURE__*/function (_Component) {
  function CheckboxDetailField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = {
      title: props.schema.title,
      value: props.value || props.formData || {
        checked: undefined,
        detail: null
      },
      detail_required: false
    };
    return _this;
  }
  _inheritsLoose(CheckboxDetailField, _Component);
  var _proto = CheckboxDetailField.prototype;
  _proto.handleCheckBoxChange = function handleCheckBoxChange(event) {
    var _this2 = this;
    var checked = event.target.checked;
    var detail = checked ? this.state.value.detail : null;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue,
      detail_required: checked
    }, function () {
      return _this2.props.onChange(newValue);
    });
    return;
  };
  _proto.handleDetailChange = function handleDetailChange(event) {
    var _this3 = this;
    var checked = true;
    var detail = event.target.value;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue
    }, function () {
      return _this3.props.onChange(newValue);
    });
    return;
  };
  _proto.render = function render() {
    var _this4 = this;
    var _this$props = this.props,
      schema = _this$props.schema,
      idSchema = _this$props.idSchema,
      disabled = _this$props.disabled,
      readonly = _this$props.readonly,
      autofocus = _this$props.autofocus,
      onBlur = _this$props.onBlur,
      onFocus = _this$props.onFocus,
      registry = _this$props.registry;
    var DescriptionField = registry.fields.DescriptionField;
    var detail_required = this.state.detail_required;
    var required = schemaRequiresTrueValue(schema);
    return /*#__PURE__*/React.createElement("div", {
      className: "field-checkbox-detail"
    }, /*#__PURE__*/React.createElement(Form.Label, null, this.title), /*#__PURE__*/React.createElement("div", {
      className: "mb-1 checkbox " + (disabled || readonly ? "disabled" : "")
    }, /*#__PURE__*/React.createElement("div", {
      className: "mb-1"
    }, this.props.schema.title), /*#__PURE__*/React.createElement("div", {
      className: "input-group mb-3"
    }, /*#__PURE__*/React.createElement("div", {
      className: "input-group-prepend"
    }, /*#__PURE__*/React.createElement("div", {
      className: "input-group-text"
    }, /*#__PURE__*/React.createElement("input", {
      type: "checkbox",
      className: "",
      id: idSchema && idSchema.$id,
      checked: typeof this.state.value.checked === "undefined" ? false : this.state.value.checked,
      required: required,
      disabled: disabled || readonly,
      autoFocus: autofocus,
      onChange: function onChange(event) {
        return _this4.handleCheckBoxChange(event);
      },
      onBlur: onBlur && idSchema && function (event) {
        return onBlur(idSchema.$id, event.target.checked);
      },
      onFocus: onFocus && idSchema && function (event) {
        return onFocus(idSchema.$id, event.target.checked);
      }
    }))), /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control",
      "aria-label": "Details",
      required: detail_required,
      value: this.state.value.detail ? this.state.value.detail : "",
      disabled: disabled || readonly || !this.state.value.checked,
      onChange: function onChange(event) {
        return _this4.handleDetailChange(event);
      },
      placeholder: schema.placeholder
    })), this.props.schema.description && /*#__PURE__*/React.createElement(DescriptionField, {
      description: this.props.schema.description
    })));
  };
  return CheckboxDetailField;
}(Component);
;
export default CheckboxDetailField;