function initListenerAutoResize() {
  var observer;
  if (window.attachEvent) {
    observer = function observer(element, event, handler) {
      element.attachEvent("on" + event, handler);
    };
  } else {
    observer = function observer(element, event, handler) {
      element.addEventListener(event, handler, false);
    };
  }
  var initListener = function initListener() {
    var resize = function resize(element) {
      return function () {
        var _element$getBoundingC = element.getBoundingClientRect(),
          height = _element$getBoundingC.height;
        if (element.scrollHeight + 2 > height) {
          element.style.height = element.scrollHeight + "px";
        }
      };
    };

    /* 0-timeout to get the already changed text */
    var delayedResize = function delayedResize(element) {
      return function () {
        window.setTimeout(resize(element), 0);
      };
    };
    var elements = document.getElementsByTagName("textarea");
    for (var index = 0; index < elements.length; index++) {
      var element = elements[index];
      observer(element, "change", resize(element));
      observer(element, "cut", delayedResize(element));
      observer(element, "paste", delayedResize(element));
      observer(element, "drop", delayedResize(element));
      observer(element, "keyup", resize(element));
      observer(element, "keydown", resize(element));
      resize(element)();
    }
  };
  initListener();
}
export { initListenerAutoResize };