function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { Component } from "react";
import { Form } from "react-bootstrap";
import { accounting } from "accounting";
import _ from "lodash";
var CurrencyWidget = /*#__PURE__*/function (_Component) {
  function CurrencyWidget(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handleFocus", function (event) {
      var value = _this.unformat(event.target.value);
      if (!parseInt(value) && !_.startsWith("-")) {
        //if value is 0 the field will reset. and value will set into empty string
        _this.setState({
          value: ""
        });
      } else {
        _this.props.onChange(value);
        _this.setState({
          value: accounting.unformat(event.target.value)
        });
      }
    });
    _defineProperty(_this, "unformat", function (value) {
      return (accounting.unformat(value) * 100).toFixed(_this.precision);
    });
    _defineProperty(_this, "handleBlur", function (event) {
      var unformattedValue = _this.unformat(event.target.value);
      _this.props.onChange(unformattedValue);
      _this.setState({
        value: accounting.formatMoney(event.target.value)
      });
    });
    _defineProperty(_this, "handleInputValueChange", function (event) {
      var isNumberAccepted = new RegExp(/(^[-|\+|0-9][0-9]*)(\.*||\.[0-9]*)$/).test(event.target.value);
      if (isNumberAccepted || _.isEmpty(event.target.value)) {
        _this.setState({
          value: event.target.value
        });
      }
    });
    _this.precision = props.options.precision === undefined ? 2 : props.options.precision;
    accounting.settings = {
      currency: {
        symbol: !props.options.symbol ? "$" : props.options.symbol,
        // default currency symbol is '$'
        format: {
          pos: !props.options.format ? "%s%v" : props.options.format,
          neg: !props.options.format ? "%s(%v)" : props.options.format,
          zero: "%s  -- "
        },
        // controls output: %s = symbol, %v = value/number
        decimal: ".",
        // decimal point separator
        thousand: ",",
        // thousands separator
        precision: _this.precision // decimal places
      },
      number: {
        precision: _this.precision,
        // default precision on numbers is 0
        thousand: ",",
        decimal: "."
      }
    };
    _this.state = _extends({}, props, {
      precision: _this.precision,
      value: accounting.formatMoney(props.value / 100)
    });
    return _this;
  }
  _inheritsLoose(CurrencyWidget, _Component);
  var _proto = CurrencyWidget.prototype;
  _proto.render = function render() {
    var _$get = _.get(this.props, "schema", {}),
      title = _$get.title;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form.Label, null, title), /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control currency",
      style: {
        textAlign: "right"
      },
      value: this.state.value,
      required: this.state.required,
      onChange: this.handleInputValueChange,
      onFocus: this.handleFocus,
      onBlur: this.handleBlur,
      disabled: this.state.disabled,
      readOnly: this.state.readonly
    }));
  };
  return CurrencyWidget;
}(Component);
export default CurrencyWidget;