"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _utils = require("@rjsf/core/lib/utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var CheckboxDetailField = /*#__PURE__*/function (_Component) {
  function CheckboxDetailField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = {
      title: props.schema.title,
      value: props.value || props.formData || {
        checked: undefined,
        detail: null
      },
      detail_required: false
    };
    return _this;
  }
  _inheritsLoose(CheckboxDetailField, _Component);
  var _proto = CheckboxDetailField.prototype;
  _proto.handleCheckBoxChange = function handleCheckBoxChange(event) {
    var _this2 = this;
    var checked = event.target.checked;
    var detail = checked ? this.state.value.detail : null;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue,
      detail_required: checked
    }, function () {
      return _this2.props.onChange(newValue);
    });
    return;
  };
  _proto.handleDetailChange = function handleDetailChange(event) {
    var _this3 = this;
    var checked = true;
    var detail = event.target.value;
    var newValue = {
      checked: checked,
      detail: detail
    };
    this.setState({
      value: newValue
    }, function () {
      return _this3.props.onChange(newValue);
    });
    return;
  };
  _proto.render = function render() {
    var _this4 = this;
    var _this$props = this.props,
      schema = _this$props.schema,
      idSchema = _this$props.idSchema,
      disabled = _this$props.disabled,
      readonly = _this$props.readonly,
      autofocus = _this$props.autofocus,
      onBlur = _this$props.onBlur,
      onFocus = _this$props.onFocus,
      registry = _this$props.registry;
    var DescriptionField = registry.fields.DescriptionField;
    var detail_required = this.state.detail_required;
    var required = (0, _utils.schemaRequiresTrueValue)(schema);
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "field-checkbox-detail"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, this.title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "mb-1 checkbox " + (disabled || readonly ? "disabled" : "")
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "mb-1"
    }, this.props.schema.title), /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group mb-3"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group-prepend"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "input-group-text"
    }, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      className: "",
      id: idSchema && idSchema.$id,
      checked: typeof this.state.value.checked === "undefined" ? false : this.state.value.checked,
      required: required,
      disabled: disabled || readonly,
      autoFocus: autofocus,
      onChange: function onChange(event) {
        return _this4.handleCheckBoxChange(event);
      },
      onBlur: onBlur && idSchema && function (event) {
        return onBlur(idSchema.$id, event.target.checked);
      },
      onFocus: onFocus && idSchema && function (event) {
        return onFocus(idSchema.$id, event.target.checked);
      }
    }))), /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      className: "form-control",
      "aria-label": "Details",
      required: detail_required,
      value: this.state.value.detail ? this.state.value.detail : "",
      disabled: disabled || readonly || !this.state.value.checked,
      onChange: function onChange(event) {
        return _this4.handleDetailChange(event);
      },
      placeholder: schema.placeholder
    })), this.props.schema.description && /*#__PURE__*/_react["default"].createElement(DescriptionField, {
      description: this.props.schema.description
    })));
  };
  return CheckboxDetailField;
}(_react.Component);
;
var _default = exports["default"] = CheckboxDetailField;
module.exports = exports.default;