"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _reactQrReader = _interopRequireDefault(require("react-qr-reader"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ReactQRReaderField = /*#__PURE__*/function (_Component) {
  function ReactQRReaderField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handleScan", function (data) {
      if (data) {
        console.log(data);
        _this.props.onChange(data);
        _this.setState({
          showScanner: false,
          value: data
        });
      }
    });
    _defineProperty(_this, "handleError", function (err) {
      console.error(err);
    });
    _defineProperty(_this, "supportsWebRTCMedia", function () {
      if (!navigator.mediaDevices || !navigator.mediaDevices.enumerateDevices) {
        return false;
      } else return true;
    });
    _defineProperty(_this, "isiOS", function () {
      return ["iPad Simulator", "iPhone Simulator", "iPod Simulator", "iPad", "iPhone", "iPod"].includes(navigator.platform)
      // iPad on iOS 13 detection
      || navigator.userAgent.includes("Mac") && "ontouchend" in document;
    });
    _this.state = _extends({}, props, {
      showScanner: false,
      value: null
    });
    return _this;
  }
  _inheritsLoose(ReactQRReaderField, _Component);
  var _proto = ReactQRReaderField.prototype;
  _proto._getQRReader = function _getQRReader() {
    var _this2 = this;
    return _reactDom["default"].createPortal(/*#__PURE__*/_react["default"].createElement("div", {
      style: {
        position: "fixed",
        top: 0,
        width: "100%",
        height: "100%",
        backgroundColor: "rgba(255, 255, 255, 0.5)"
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactQrReader["default"], {
      delay: 500,
      onError: this.handleError,
      onScan: this.handleScan,
      className: "QRReader_container",
      style: {
        width: "100%"
      },
      facingMode: "environment"
    }), /*#__PURE__*/_react["default"].createElement("button", {
      style: {
        width: "100%",
        position: "absolute",
        bottom: 0,
        borderRadius: 0,
        margin: "auto",
        zIndex: 10
      },
      onClick: function onClick() {
        return _this2.setState({
          showScanner: false
        });
      },
      className: "btn btn-block btn-secondary"
    }, "Close")), document.getElementsByTagName("body")[0]);
  };
  _proto.render = function render() {
    var _this3 = this;
    return /*#__PURE__*/_react["default"].createElement("span", null, this.state.showScanner ? this._getQRReader() : /*#__PURE__*/_react["default"].createElement("span", null, this.state.value && /*#__PURE__*/_react["default"].createElement("span", {
      className: "mr-2"
    }, this.state.value), this.isiOS() && !this.supportsWebRTCMedia() ? /*#__PURE__*/_react["default"].createElement("button", {
      className: "btn btn-sm btn-outline-danger",
      onClick: function onClick(e) {
        e.preventDefault();
        alert("This browser does not support the camera. On iPhone, use Safari.");
      }
    }, "QR") : /*#__PURE__*/_react["default"].createElement("button", {
      onClick: function onClick() {
        return _this3.setState({
          showScanner: true
        });
      },
      className: "btn btn-sm btn-secondary"
    }, "QR"), this.state.value && /*#__PURE__*/_react["default"].createElement("button", {
      onClick: function onClick() {
        var clearValue = confirm("Are you sure?");
        if (clearValue) _this3.setState({
          value: null
        });
      },
      className: "btn btn-sm btn-secondary ml-1"
    }, "\xD7")));
  };
  return ReactQRReaderField;
}(_react.Component);
var _default = exports["default"] = ReactQRReaderField;
module.exports = exports.default;