"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactSignatureCanvas = _interopRequireDefault(require("react-signature-canvas"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var ReactSignatureCanvasField = /*#__PURE__*/function (_Component) {
  function ReactSignatureCanvasField(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = _extends({}, props, {
      width: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].width || 400,
      height: props.uiSchema["ui:options"] && props.uiSchema["ui:options"].height || 150,
      value: props.formData || ""
    });
    return _this;
  }
  _inheritsLoose(ReactSignatureCanvasField, _Component);
  var _proto = ReactSignatureCanvasField.prototype;
  _proto.componentDidMount = function componentDidMount() {
    if (!this.state.readonly && this.sigCanvas) this.sigCanvas.fromDataURL(this.state.formData);
  };
  _proto._clear = function _clear(e) {
    e.preventDefault();
    var confirmed = confirm("Clear the signature?");
    if (confirmed) {
      this.sigCanvas.clear();
      this.setState({
        value: ""
      });
      this.state.onChange();
    } else {
      return false;
    }
  };
  _proto.render = function render() {
    var _this2 = this;
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        position: "relative",
        width: this.state.width + 41,
        minHeight: this.state.height + 40
      }
    }, !this.state.readonly ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactSignatureCanvas["default"], {
      ref: function ref(_ref) {
        _this2.sigCanvas = _ref;
      },
      penColor: "black",
      canvasProps: {
        width: this.state.width,
        height: this.state.height,
        className: "sigCanvas",
        style: {
          border: "#ddd 3px dashed",
          borderRadius: 4
        }
      },
      backgroundColor: "#fafafa",
      onEnd: function onEnd(value) {
        _this2.state.onChange(_this2.sigCanvas.toDataURL(value));
        _this2.setState({
          value: _this2.sigCanvas.toDataURL(value)
        });
      }
    }), /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      style: {
        border: 0,
        height: 1,
        width: 1
      },
      value: this.state.value,
      onChange: function onChange(event) {
        return _this2.state.value;
      },
      readOnly: true,
      required: this.state.required
    }), this.sigCanvas && !this.sigCanvas.isEmpty() ? /*#__PURE__*/_react["default"].createElement("button", {
      className: "btn btn-secondary d-print-none",
      style: {
        position: "absolute",
        right: 0,
        top: 0,
        height: this.state.height + 6,
        fontSize: 16,
        fontWeight: "700",
        borderTopLeftRadius: 0,
        borderBottomLeftRadius: 0,
        borderWidth: 3
      },
      onClick: this._clear.bind(this)
    }, "\xD7") : null) : this.state.formData ? /*#__PURE__*/_react["default"].createElement("img", {
      style: {
        minHeight: this.state.height
      },
      src: this.state.formData
    }) : /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        minHeight: this.state.height,
        fontWeight: "700",
        lineHeight: this.state.height + "px",
        color: "#666",
        backgroundColor: "#fafafa",
        textAlign: "center"
      }
    }, "No Signature"), /*#__PURE__*/_react["default"].createElement("div", {
      className: "sigSalutation"
    }, /*#__PURE__*/_react["default"].createElement("h6", {
      style: {
        paddingTop: 10,
        marginTop: 15,
        borderTop: "#444 1px solid"
      }
    }, this.state.schema.title)));
  };
  return ReactSignatureCanvasField;
}(_react.Component);
var _default = exports["default"] = ReactSignatureCanvasField;
module.exports = exports.default;