"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactBootstrap = require("react-bootstrap");
require("intelligent-tree-select/lib/styles.css");
var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ReactTreeSelectFieldOption = /*#__PURE__*/function (_Component) {
  function ReactTreeSelectFieldOption() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _defineProperty(_this, "handleClick", function (event) {
      var props = _this.props;
      if (!_this.props.option.isEnd) {
        event.stopPropagation();
        return;
      }
      _this.props.selectValue(_this.props.option);
      console.log(event, props);
    });
    _defineProperty(_this, "handleToggle", function () {
      _this.props.focusOption(_this.props.option);
      _this.props.toggleOption(_this.props.option);
      _this.props.select.current.forceUpdate();
    });
    _defineProperty(_this, "isOptionSelected", function () {
      return _lodash["default"].some(_this.props.valueArray, function (selectedOption) {
        return selectedOption.value === _this.props.option.value;
      });
    });
    return _this;
  }
  _inheritsLoose(ReactTreeSelectFieldOption, _Component);
  var _proto = ReactTreeSelectFieldOption.prototype;
  _proto.render = function render() {
    var fetching = this.props.select.current.state.isLoadingExternally;
    var expanded = this.props.option.expanded;
    var isSelected = this.isOptionSelected();
    return /*#__PURE__*/_react["default"].createElement("li", {
      style: _extends({
        listStyleType: "none"
      }, this.props.optionStyle)
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, {
      style: {
        margin: "5px"
      },
      className: "align-items-center"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      xs: "auto",
      md: "auto",
      onClick: this.handleToggle,
      style: {
        padding: "0 5px",
        margin: 0
      },
      className: "btn"
    }, fetching && "" + this.props.focusedOptionIndex === "" + this.props.optionIndex && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Spinner, {
      size: "sm",
      animation: "border"
    }), !(fetching && "" + this.props.focusedOptionIndex === "" + this.props.optionIndex) && !this.props.option.isEnd && /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactFontawesome["default"], {
      name: expanded ? "minus-circle" : "plus-circle"
    }))), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
      xs: "auto",
      style: {
        padding: 0,
        margin: 0,
        fontWeight: isSelected ? "bold" : "normal"
      },
      className: "btn",
      onClick: this.handleClick
    }, this.props.option.label)));
  };
  return ReactTreeSelectFieldOption;
}(_react.Component);
;
var _default = exports["default"] = ReactTreeSelectFieldOption;
module.exports = exports.default;