"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _AddButton = _interopRequireDefault(require("@rjsf/core/lib/components/AddButton"));
var _utils = require("@rjsf/core/lib/utils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function BasicObjectFieldTemplate(props) {
  var idSchema = props.idSchema,
    TitleField = props.TitleField,
    DescriptionField = props.DescriptionField;
  var canExpand = function canExpand() {
    var formData = props.formData,
      schema = props.schema,
      uiSchema = props.uiSchema;
    if (!schema.additionalProperties) {
      return false;
    }
    var _getUiOptions = (0, _utils.getUiOptions)(uiSchema),
      expandable = _getUiOptions.expandable;
    if (expandable === false) {
      return expandable;
    }
    // if ui:options.expandable was not explicitly set to false, we can add
    // another property if we have not exceeded maxProperties yet
    if (schema.maxProperties !== undefined) {
      return Object.keys(formData).length < schema.maxProperties;
    }
    return true;
  };
  return /*#__PURE__*/_react["default"].createElement("fieldset", {
    id: props.idSchema.$id
  }, (props.uiSchema["ui:title"] || props.title) && /*#__PURE__*/_react["default"].createElement(TitleField, {
    id: props.idSchema.$id + "__title",
    title: props.title || props.uiSchema["ui:title"],
    required: props.required,
    formContext: props.formContext
  }), props.description && /*#__PURE__*/_react["default"].createElement(DescriptionField, {
    id: props.idSchema.$id + "__description",
    description: props.description,
    formContext: props.formContext
  }), props.properties.map(function (prop) {
    return prop.content;
  }), canExpand() && /*#__PURE__*/_react["default"].createElement(_AddButton["default"], {
    className: "object-property-expand",
    onClick: props.onAddClick(props.schema),
    disabled: props.disabled || props.readonly
  }));
}
var _default = exports["default"] = BasicObjectFieldTemplate;
module.exports = exports.default;