"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDatepicker = _interopRequireDefault(require("react-datepicker"));
var _lodash = _interopRequireDefault(require("lodash"));
require("react-datepicker/dist/react-datepicker.css");
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ButtonInput = /*#__PURE__*/function (_React$Component) {
  function ButtonInput() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "handleClick", function (e) {
      e.preventDefault();
      _this.props.onClick(e);
    });
    return _this;
  }
  _inheritsLoose(ButtonInput, _React$Component);
  var _proto = ButtonInput.prototype;
  _proto.render = function render() {
    var value = this.props.value;
    if (value && this.props.displayFormat) value = (0, _moment["default"])(this.props.value).format(this.props.displayFormat);
    return /*#__PURE__*/_react["default"].createElement("a", {
      className: "btn btn-sm btn-secondary",
      href: "#!",
      onClick: this.handleClick
    }, value || /*#__PURE__*/_react["default"].createElement("span", {
      className: "d-print-none"
    }, "Choose Date"));
  };
  return ButtonInput;
}(_react["default"].Component);
ButtonInput.propTypes = process.env.NODE_ENV !== "production" ? {
  onClick: _propTypes["default"].func,
  value: _propTypes["default"].string
} : {};
var ReactDatePickerWidget = /*#__PURE__*/function (_Component) {
  function ReactDatePickerWidget(props) {
    var _this2;
    _this2 = _Component.call(this, props) || this;
    _this2.state = _extends({}, props);
    _this2.dataFormat = null;
    _this2.displayFormat = "MM/DD/YYYY";
    if (_this2.state.options && _this2.state.options.format) {
      if (typeof _this2.state.options.format === "object" && _this2.state.options.format !== null) {
        _this2.dataFormat = _this2.state.options.format.data;
        _this2.displayFormat = _this2.state.options.format.display;
      } else {
        _this2.dataFormat = _this2.state.options.format;
        _this2.displayFormat = _this2.state.options.format;
      }
    }
    return _this2;
  }
  _inheritsLoose(ReactDatePickerWidget, _Component);
  var _proto2 = ReactDatePickerWidget.prototype;
  _proto2.render = function render() {
    var _this3 = this;
    var _$get = _lodash["default"].get(this.props, "schema", {}),
      title = _$get.title;
    var selected = null;
    if (this.state.value) selected = (0, _moment["default"])(this.state.value, this.dataFormat).toDate();
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Label, null, title), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: "block"
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactDatepicker["default"], {
      customInput: /*#__PURE__*/_react["default"].createElement(ButtonInput, {
        displayFormat: this.displayFormat
      }),
      selected: selected,
      required: this.state.required,
      onChange: function onChange(date) {
        var value = date;
        if (_this3.dataFormat) value = (0, _moment["default"])(date).format(_this3.dataFormat);else value = (0, _moment["default"])(value).toISOString();
        _this3.setState({
          value: date
        }, function () {
          return _this3.state.onChange(value);
        });
      },
      strictParsing: true,
      disabled: this.state.disabled,
      readOnly: this.state.readonly,
      isClearable: true
    }), /*#__PURE__*/_react["default"].createElement("input", {
      name: this.props.id,
      id: this.props.id,
      style: {
        position: "absolute",
        border: 0,
        width: 1,
        height: 1
      },
      type: "text",
      onChange: function onChange(event) {
        return _this3.state.value;
      },
      required: this.props.required,
      value: this.state.value || ""
    })));
  };
  return ReactDatePickerWidget;
}(_react.Component);
var _default = exports["default"] = ReactDatePickerWidget;
module.exports = exports.default;