"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactBootstrap = require("react-bootstrap");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ButtonInputTable = /*#__PURE__*/function (_React$Component) {
  function ButtonInputTable() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "state", {
      checkbox: true
    });
    _defineProperty(_this, "handleButtonClick", function (rowData, colData, currentValue) {
      var onChange = _this.props.onChange;
      return function () {
        var newData = {
          row: rowData,
          column: colData,
          value: currentValue
        };
        onChange && onChange(newData);
      };
    });
    _defineProperty(_this, "isCellValueChecked", function (rowData, colData, optionCellValue) {
      var formData = _this.props.formData;
      return optionCellValue === formData.value && rowData === formData.row && colData === formData.column;
    });
    return _this;
  }
  _inheritsLoose(ButtonInputTable, _React$Component);
  var _proto = ButtonInputTable.prototype;
  _proto.renderCell = function renderCell(rowData, colData, rowIndex, colIndex) {
    var optionValueMatrix = _lodash["default"].get(this.props, "uiSchema.ui:options.values", []);
    var optionCellValue = _lodash["default"].get(optionValueMatrix, rowIndex + "." + colIndex, null);
    var isSelected = this.isCellValueChecked(rowData, colData, optionCellValue);
    return optionCellValue ? /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      as: "span",
      className: "buttonCell",
      variant: isSelected ? "secondary" : "outlined",
      active: isSelected,
      onClick: this.handleButtonClick(rowData, colData, optionCellValue)
    }, optionCellValue) : "";
  };
  _proto.render = function render() {
    var _this2 = this;
    var _$get = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
      rows = _$get.rows,
      columns = _$get.columns;
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Table, {
      responsive: true
    }, /*#__PURE__*/_react["default"].createElement("tbody", null, _lodash["default"].map(rows, function (rowData, rowIndex) {
      return /*#__PURE__*/_react["default"].createElement("tr", {
        key: rowIndex,
        className: "input_table_row input_table_row-" + rowIndex
      }, /*#__PURE__*/_react["default"].createElement("td", {
        className: "headerCell"
      }, /*#__PURE__*/_react["default"].createElement("b", null, rowData)), _lodash["default"].map(columns, function (colData, colIndex) {
        return /*#__PURE__*/_react["default"].createElement("td", {
          key: colIndex,
          className: "input_table_cell input_table_cell_" + rowIndex + "-" + colIndex
        }, _this2.renderCell(rowData, colData, rowIndex, colIndex));
      }));
    }), /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("th", null), _lodash["default"].map(columns, function (colData, colIndex) {
      return /*#__PURE__*/_react["default"].createElement("th", {
        key: colIndex
      }, colData);
    }))));
  };
  return ButtonInputTable;
}(_react["default"].Component);
var _default = exports["default"] = ButtonInputTable;
module.exports = exports.default;