"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = _interopRequireDefault(require("lodash"));
var _reactBootstrap = require("react-bootstrap");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _inheritsLoose(t, o) { t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var CheckboxInputTable = /*#__PURE__*/function (_React$Component) {
  function CheckboxInputTable() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _defineProperty(_this, "state", {
      checkbox: true
    });
    _defineProperty(_this, "handleChange", function (rowData, colData, rowIndex, colIndex) {
      return function (e) {
        var _this$props = _this.props,
          onChange = _this$props.onChange,
          formData = _this$props.formData;
        var valuesInRow = _lodash["default"].get(formData, rowData, []);
        var isIncludedBefore = _lodash["default"].includes(valuesInRow, colData);
        if (isIncludedBefore) {
          valuesInRow = _lodash["default"].reject(valuesInRow, function (value) {
            return value === colData;
          });
        } else {
          valuesInRow.push(colData);
        }
        var obj = _extends({}, formData);
        obj[rowData] = valuesInRow;
        onChange && onChange(obj);
        _this.forceUpdate();
      };
    });
    _defineProperty(_this, "isCellValueChecked", function (rowData, colData) {
      var formData = _this.props.formData;
      var rowValues = _lodash["default"].get(formData, rowData, []);
      return _lodash["default"].includes(rowValues, colData);
    });
    return _this;
  }
  _inheritsLoose(CheckboxInputTable, _React$Component);
  var _proto = CheckboxInputTable.prototype;
  _proto.renderCell = function renderCell(rowData, colData, rowIndex, colIndex) {
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Form.Check, {
      checked: this.isCellValueChecked(rowData, colData),
      name: "radioGroup-" + this.id + "-" + rowIndex,
      onChange: this.handleChange(rowData, colData, rowIndex, colIndex),
      type: "checkbox",
      style: {
        display: "flex",
        justifyContent: "center"
      }
    });
  };
  _proto.renderTable = function renderTable() {
    var _this2 = this;
    var _$get = _lodash["default"].get(this.props, "uiSchema.ui:options", {}),
      rows = _$get.rows,
      columns = _$get.columns;
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Table, {
      responsive: true
    }, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("th", null), _lodash["default"].map(columns, function (data, index) {
      return /*#__PURE__*/_react["default"].createElement("th", {
        key: index
      }, data);
    }))), /*#__PURE__*/_react["default"].createElement("tbody", null, _lodash["default"].map(rows, function (rowData, rowIndex) {
      return /*#__PURE__*/_react["default"].createElement("tr", {
        key: rowIndex
      }, /*#__PURE__*/_react["default"].createElement("td", {
        key: rowIndex
      }, rowData), _lodash["default"].map(columns, function (colData, colIndex) {
        return /*#__PURE__*/_react["default"].createElement("td", {
          key: colIndex
        }, _this2.renderCell(rowData, colData, rowIndex, colIndex));
      }));
    })));
  };
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, this.renderTable());
  };
  return CheckboxInputTable;
}(_react["default"].Component);
var _default = exports["default"] = CheckboxInputTable;
module.exports = exports.default;